Exporter (0) Imprimer
Développer tout

Exception.HResult, propriété

Obtient ou définit HRESULT, valeur numérique codée qui est assignée à une exception spécifique.

Espace de noms : System
Assembly : mscorlib (dans mscorlib.dll)

protected int HResult { get; set; }
/** @property */
protected int get_HResult ()

/** @property */
protected void set_HResult (int value)

protected function get HResult () : int

protected function set HResult (value : int)

Valeur de la propriété

Valeur HRESULT.

HRESULT est une valeur 32 bits divisée en trois champs : un code de gravité, un code de service et un code d'erreur. Le code de gravité indique si la valeur de retour représente une information, un avertissement ou une erreur. Le code de service identifie la zone du système responsable de l'erreur. Le code d'erreur est un numéro unique assigné pour représenter l'exception. Chaque exception est mappée à une valeur HRESULT distincte. Lorsque du code managé lève une exception, le runtime passe la valeur HRESULT au client COM. Lorsque du code non managé retourne une erreur, la valeur HRESULT est convertie en une exception qui est ensuite levée par le runtime.

L'exemple de code suivant définit une classe Exception dérivée qui définit la propriété HResult dans son constructeur.

// Example for the Exception.HResult property.
using System;

namespace NDP_UE_CS
{
    // Create the derived exception class.
    class SecondLevelException : Exception
    {
        const int SecondLevelHResult = unchecked( (int)0x81234567 );

        // Set HResult for this exception, and include it in 
        // the exception message.
        public SecondLevelException( string message, Exception inner ) :
            base( string.Format( "(HRESULT:0x{1:X8}) {0}", 
                message, SecondLevelHResult ), inner )
        {
            HResult = SecondLevelHResult;
        }
    }

    class HResultDemo 
    {
        public static void Main() 
        {
            Console.WriteLine( 
                "This example of Exception.HResult " +
                "generates the following output.\n" );

            // This function forces a division by 0 and throws 
            // a second exception.
            try
            {
                try
                {
                    int  zero = 0;
                    int  ecks = 1 / zero;
                }
                catch( Exception ex )
                {
                    throw new SecondLevelException( 
                        "Forced a division by 0 and threw " +
                        "a second exception.", ex );
                }
            }
            catch( Exception ex )
            {
                Console.WriteLine( ex.ToString( ) );
            }
        }
    }
}

/*
This example of Exception.HResult generates the following output.

NDP_UE_CS.SecondLevelException: (HRESULT:0x81234567) Forced a division by 0 and
 threw a second exception. ---> System.DivideByZeroException: Attempted to divi
de by zero.
   at NDP_UE_CS.HResultDemo.Main()
   --- End of inner exception stack trace ---
   at NDP_UE_CS.HResultDemo.Main()
*/

// Example for the Exception.HResult property.
package NDP_UE_JSL ; 

import System.* ;

// Create the derived exception class.
class SecondLevelException  extends System.Exception
{
    private int SecondLevelHResult = (int)(0x81234567);

    // Set HResult for this exception, and include it in 
    // the exception message.
    public SecondLevelException(String message, System.Exception inner)
    {
        super(String.Format("(HRESULT:0x{1:X8}) {0}", message, 
            ((System.Int32)(int)(0x81234567)).ToString("X8")), inner);
        set_HResult(SecondLevelHResult);
    } //SecondLevelException
} //SecondLevelException

class HResultDemo
{
    public static void main(String[] args)
    {
        Console.WriteLine(("This example of Exception.HResult " 
            + "generates the following output.\n"));

        // This function forces a division by 0 and throws 
        // a second exception.
        try {
            try {
                int zero = 0;
                int ecks = 1 / zero;
            }
            catch (System.Exception ex) {
                throw new SecondLevelException("Forced a division by 0 and " 
                    + "threw a second exception.", ex);
            }
        }
        catch (System.Exception ex) {
            Console.WriteLine(ex.toString());
        }
    } //main
} //HResultDemo
   
/*
This example of Exception.HResult generates the following output.

NDP_UE_JSL.SecondLevelException: (HRESULT:0x81234567) Forced a division by 0 
and threw a second exception. ---> System.DivideByZeroException: Attempted to 
divi de by zero.
   at NDP_UE_JSL.HResultDemo.Main()
   --- End of inner exception stack trace ---
   at NDP_UE_JSL.HResultDemo.Main()
*/

Windows 98, Windows 2000 SP4, Windows CE, Windows Millennium Edition, Windows Mobile pour Pocket PC, Windows Mobile pour Smartphone, Windows Server 2003, Windows XP Édition Media Center, Windows XP Professionnel Édition x64, Windows XP SP2, Windows XP Starter Edition

Le .NET Framework ne prend pas en charge toutes les versions de chaque plate-forme. Pour obtenir la liste des versions prises en charge, consultez Configuration requise.

.NET Framework

Prise en charge dans : 2.0, 1.1, 1.0

.NET Compact Framework

Prise en charge dans : 2.0

Ajouts de la communauté

AJOUTER
Afficher:
© 2015 Microsoft